##For a more detailed explaination on 'Equivalence of Solutions', see.
##"Matthews Method for Solving ax^2 + bxy + cy^2 = N ",
##Page 3. 'Chinese Remainder Method' by 'John Robertson'.
##Chinese Remainder Modulo sourced from Rosetta Code
##A worked example of Chinese Remainder Modulo can be found at
##https://www.geeksforgeeks.org/multiplicative-inverse-under-modulo-m
##There maybe Bugs (Division by Zero, Matrix input, Choice 3), ect.
##Obviously, large Integers requires,Generator Yield, Coprocessors, ect.
##Checked with example. 11x^2 + 23xy - 20y^2 = 14. 
##Paste Required Imports into Python 'Idle' prompt >>
import math
from math import gcd
from functools import reduce
import itertools 
##Paste each def code into Python idle
##By Warren B......To run menu,>> Main_BQF_CRT()

def Main_BQF_CRT():
    loop_conditionN = True
    while loop_conditionN == True:
        print (" Binary Quadratic Forms, Chinese Remainder Theorem ")
        print ("Choose option 7. For alternate search for small Unimodular Matrix")
        print ("(a,y) with gcd = 1. Or sequentially 'BQF_CRT' Options. 1 to 6.")
        print ("1. FIRST. Check that gcd(a,N) != 1, before proceeding!")
        print ("2. List of Primes divides N")
        print ("3. xi and yi for; X = xi(mod qi) and Y = yi(mod qi)")
        print ("4. Chinese Remainder Modulo")
        print ("5. a = X/gcd(X,Y) & y = Y/gcd(X,Y) & A = aa^2+bay+cy^2")
        print ("6. Test: gcd Unimodular Matrix(a,y) = 1 and gcd Eqivalence and Total(A,N) = 1")
        print ("7. An Alternative Interpretation of the 'Hua' method. For 'BQF_CRT' ")
        print ("8. Exit")
        Main_Choice_BQF_CRT = int(input("Choose an Option:   "))
        if (Main_Choice_BQF_CRT == 8):
            loop_conditionN = False
            break
        elif (Main_Choice_BQF_CRT == 1):
            print ("1---------")
            ax = int(input("From , 'ax^2' in ax^2 + bxy + cy^2 = N, Enter number a "))
            Nn_Prime_List1 = int(input("From ,'N' in ax^2 + bxy + cy^2 = N, Enter 'N' "))
            Is_Equiv_Req1(ax,Nn_Prime_List1)
            print("")
        elif (Main_Choice_BQF_CRT == 2):
            print ("2---------")
            Nn_Prime_List1 = int(input("From ,'N' in ax^2 + bxy + cy^2 = N, Enter 'N' "))
            Ret_List_k_1 = List_of_Prime2(Nn_Prime_List1)
            print("List of Primes that devide 'N'")
            print(Ret_List_k_1)
            print("")
            print("Search on, 'Small' Unimodular 'a'&'y' with gcd(a,y) = 1 ")
            print("Set, A = aa^2+bay+cy^2 and test wether gcd(A,N) = 1 ")
            print("This can frequently find 'a'&'y' very quickly, ")
            print("with smaller Transformed Equation Co-efficients, Than Choice 7.")
            print("")
        elif (Main_Choice_BQF_CRT == 3):
            print ("3----------")
            ax = int(input("From , 'ax^2' in ax^2 + bxy + cy^2 = N, Enter number a "))
            cy = int(input("From , 'cy^2' in ax^2 + bxy + cy^2 = N, Enter number c "))
            Nqi = int(input("From Choice 1, 'qi' in List of Primes that devide 'N', Enter number qi "))
            Ret_Div_k_1 = GCD_for_qi(ax,cy,Nqi)
            print("")
            print("The xi and yi values are ", Ret_Div_k_1 ,"For X= xi(mod qi) and Y= yi(mod qi)")
            print("")
        elif (Main_Choice_BQF_CRT == 4):
            print ("4----------")
            nNumber = eval(input("Enter xi or yi , as per Choice 2, ie multiple entry, separated by a comma "))
            aRemainder = eval(input("Enter qi's ,per Choice 1, Again, equal amount of entry's, separated by comma's "))
            Ret_CRT_k_1 = chinese_remainder(nNumber, aRemainder)
            print("")
            print("Depending on choice of X,Y, Value is = ",Ret_CRT_k_1)
            print("Depending on choice of X,Y, Check that, aX^2 + bXY + cY^2, is relatively prime to qi & N")
            print("")
        elif (Main_Choice_BQF_CRT == 5):
            print ("5----------")
            X_Num_Eqiv1 = int(input("Enter X, as per Output Choice 3, "))
            Y_Num_Eqiv1 = int(input("Enter Y, as per Output Choice 3, "))
            ax = int(input("From , 'ax^2' in ax^2 + bxy + cy^2 = N, Enter number a "))
            bxy = int(input("From , 'bxy' in ax^2 + bxy + cy^2 = N, Enter number b "))
            cy = int(input("From , 'cy^2' in ax^2 + bxy + cy^2 = N, Enter number c "))
            Ret_X_Y_and_A1 = GCD_for_X_Y_and_A(ax,bxy,cy,X_Num_Eqiv1,Y_Num_Eqiv1)
            print("")
            print("The Unimodular Matrix 'a' , 'y' and Resolved Equivalence 'A'. Value's are = ",Ret_X_Y_and_A1)
            print("")
        elif (Main_Choice_BQF_CRT == 6):
            print ("6----------")
            Unimod_a = int(input("Enter Unimodular 'a', as per Output Choice 4, "))
            Unimod_y = int(input("Enter Unimodular 'y', as per Output Choice 4, "))
            Equiv_A = int(input("Enter Equivalence 'A', as per Output Choice 4, "))
            ToT_N = int(input("From , 'N' in ax^2 + bxy + cy^2 = N, Enter number N "))
            print("")
            Ret_x_y_and_A_N1 = GCD_for_x_y_and_A_N(Unimod_a,Unimod_y,Equiv_A,ToT_N)
            print("")
        elif (Main_Choice_BQF_CRT == 7):
            print ("7----------")
            Nn_ax = int(input("From , 'ax^2' in ax^2 + bxy + cy^2 = N, Enter number a "))
            Nn_bxy = int(input("From , 'bxy' in ax^2 + bxy + cy^2 = N, Enter number b "))
            Nn_cy = int(input("From , 'cy^2' in ax^2 + bxy + cy^2 = N, Enter number c "))
            Nn_Prime_List1 = int(input("From ,'N' in ax^2 + bxy + cy^2 = N, Try a positive 'N' "))
            Ret_List_k_1 = List_of_Prime2(Nn_Prime_List1)
            print("List of Primes that devide 'N'")
            print(Ret_List_k_1)
            print("")
            Lcd_checker2(Nn_Prime_List1,Nn_ax,Nn_cy)
            print("")
        elif (Main_Choice_BQF_CRT == 8):
            print ("8----------")
        else:
            print ("Choice Not Avail")
            
##Paste each def code into Python idle
            
from math import gcd 
def Is_Equiv_Req1(ax,Nn_Prime_List1):
    if(gcd(ax,Nn_Prime_List1)== 1):
        print("No Equivalence Transform req")
    elif(gcd(ax,Nn_Prime_List1)!= 1):
        print("Proceed, Equivalence Transform req")
        
##Paste each def code into Python idle
            
import math
def List_of_Prime2(Nn_Prime_List1):
    PrimeList1 = []
    max1 = abs(Nn_Prime_List1)
    for x_i in range(2,max1 +1):
        isPrime1 = True
        for y_j in range(2,int(math.sqrt(x_i))+1):
            if(x_i%y_j)== 0:
                isPrime1=False
                break
        if isPrime1:
            PrimeList1.append(x_i)
    return(PrimeList1)

##Paste each def code into Python idle

from math import gcd            
def GCD_for_qi(ax,cy,Nqi):
    PrmDiv_xi = 0
    PrmDiv_yi = 0
    PrmDiv_k = []
    if(gcd(ax,Nqi)== 1):##This condition Division by Zero ?
        PrmDiv_xi = 1 #Ie see Menu Choice 1 and PQa, redundancy.
        PrmDiv_yi = 0 #'J.P.Robertson' Paper. ie Doubly Periodic
        PrmDiv_k.append(PrmDiv_xi)
        PrmDiv_k.append(PrmDiv_yi)
        return(PrmDiv_k)
    if(gcd(cy,Nqi)== 1):##This condition can switch!
        PrmDiv_xi = 0 #Ie see Menu Choice 1 and PQa, redundancy.
        PrmDiv_yi = 1 #'J.P.Robertson' Paper. ie Doubly Periodic
        PrmDiv_k.append(PrmDiv_xi)
        PrmDiv_k.append(PrmDiv_yi)
        return(PrmDiv_k)
    if(gcd(cy,Nqi)!= 1)and(gcd(ax,Nqi)!= 1):
        PrmDiv_xi = 1 #This is a start towards Triply Periodic
        PrmDiv_yi = 1 #
        PrmDiv_k.append(PrmDiv_xi)
        PrmDiv_k.append(PrmDiv_yi)
        return(PrmDiv_k)

##Paste each def code into Python idle
##Rosetta Org, Chinese Remainder Theorem Code
    
from functools import reduce
def chinese_remainder(n, a):
    sum = 0
    prod = reduce(lambda a, b: a*b, n)
    for n_i, a_i in zip(n, a):
        p = prod // n_i
        sum += a_i * mul_inv(p, n_i) * p
    return sum % prod

##Cut and Paste Python Code into Idle.
##Rosetta Org, Chinese Remainder Theorem Code Continued

def mul_inv(a, b):
    b0 = b
    x0, x1 = 0, 1
    if b == 1: return 1
    while a > 1:
        q = a // b
        a, b = b, a%b
        x0, x1 = x1 - q * x0, x0
    if x1 < 0: x1 += b0
    return x1

##Cut and Paste Python Code into Idle.

from math import gcd 
def GCD_for_X_Y_and_A(ax,bxy,cy,X_Num_Eqiv1,Y_Num_Eqiv1):
    Unimod_a = 0
    Unimod_y = 0
    Equiv_A = 0
    Unimod_a = X_Num_Eqiv1/(gcd(X_Num_Eqiv1,Y_Num_Eqiv1))
    Unimod_y = Y_Num_Eqiv1/(gcd(X_Num_Eqiv1,Y_Num_Eqiv1))
    Equiv_A = (ax*pow(Unimod_a,2))+(bxy*Unimod_a*Unimod_y)+(cy*pow(Unimod_y,2))
    return(Unimod_a,Unimod_y,Equiv_A)

##Cut and Paste Python Code into Idle.

from math import gcd
def GCD_for_x_y_and_A_N(Unimod_a,Unimod_y,Equiv_A,ToT_N):
    if(gcd(Unimod_a,Unimod_y)== 1):
        print("OK. Unimodular Matrix 'a','y'. gcd = 1")
    if(gcd(Unimod_a,Unimod_y)!= 1):
        print("Check ?. Unimodular Matrix 'a','y'. gcd != 1")
    if(gcd(Equiv_A,ToT_N)== 1):
        print("OK. Equivalence 'A' and Total 'N'. gcd = 1")
    if(gcd(Equiv_A,ToT_N)!= 1):
        print("Check ?. Equivalence 'A' and Total 'N'. gcd != 1")

###################################################################3
##Option 7. Python Code.
##Cut and Paste Python Code into Idle.
import itertools   
from math import gcd  
def Lcd_checker2(Nn_Prime_List1,Nn_ax,Nn_cy):
    cTrue = False
    N_ntc = 1
    N_ntc_N = 0
    divisorc2 = dict()
    divisorc2 = Cou_Divisorc(Nn_Prime_List1)
    lengt_Divisorc2 = len(divisorc2)
    while N_ntc < lengt_Divisorc2:
        axorc2 = int(divisorc2[N_ntc])
        if(gcd(Nn_ax, axorc2)==1)and(gcd(Nn_cy, axorc2)==1):##could inc 'bxy'
            print("OK. Equivalence 'N' is = ",divisorc2[N_ntc])
            N_ntc_N += 1
        if(N_ntc_N == 0)and((N_ntc + 1) == lengt_Divisorc2):
            print("No Equivalence 'N' yielded with method, for this data set.")
        N_ntc += 1

##Cut and Paste Python Code into Idle.            

def Cou_Divisorc(Nn_Prime_List1):
    divisorc = []
    Coupd = 1
    while(Coupd*Coupd < Nn_Prime_List1):
        if Nn_Prime_List1 % Coupd == 0:
            divisorc.append(Coupd)
            divisorc.append(Nn_Prime_List1 / Coupd);
        Coupd += 1
    if Coupd*Coupd == Nn_Prime_List1:
        divisorc.append(Coupd)
    return sorted(divisorc)
        
    
        
    
    
    
        
        
        
        
    
